/*
PALETTES
Read palettes from a JSON file
*/

// array of palettes
public color[][] palettes;
public String[] palette_name;

// read palettes from JSON  
void load_palettes(String filename)
{
  println("Loading palettes...");
  
  // load JSON ]array of palettes
  JSONArray palettes_json = loadJSONArray(filename);
  palettes = new color[palettes_json.size()][];
  palette_name = new String[palettes_json.size()];

  // for each palette element...  
  for (int palette_index = 0; palette_index < palettes_json.size(); ++palette_index)
  {
    // get the JSON palette object 
    JSONObject palette_json = palettes_json.getJSONObject(palette_index);
    palette_name[palette_index] = palette_json.getString("name");
    println(String.format("palette %d: %s", palette_index, palette_name[palette_index]));
    
    // get the JSON color array
    JSONArray colors_json = palette_json.getJSONArray("colors");
    palettes[palette_index] = new color[colors_json.size()];
    
    // for each color...
    for (int color_index = 0; color_index < colors_json.size(); ++color_index)
    {
      // get the JSON color
      JSONArray color_json = colors_json.getJSONArray(color_index);
      palettes[palette_index][color_index] = color(color_json.getInt(0), color_json.getInt(1), color_json.getInt(2));
    }
  }
}
